RESTCONF Extension to Support Trace Context Headers
Internet-Draft draft-ietf-netconf-restconf-trace-ctx-headers-02
Roque Gagliano
Cisco Systems
Avenue des Uttins 5
Rolle
1180
Switzerland
rogaglia@cisco.com
Kristian Larsson
Deutsche Telekom AG
kll@dev.terastrm.net
Jan Lindblad
Cisco Systems
jlindbla@cisco.com
25 September 2024
Operations and Management
NETCONF
telemetry
distributed systems
opentelemetry
This document defines an extension to the RESTCONF protocol in order to support Trace Context propagation as defined by the W3C.
About This Document
The latest revision of this draft can be found at https://github.com/netconf-wg/restconf-trace-ctx-headers/blob/gh-pages/draft-ietf-netconf-restconf-trace-ctx-headers.txt. Status information for this document may be found at https://datatracker.ietf.org/doc/draft-ietf-netconf-restconf-trace-ctx-headers/.
Discussion of this document takes place on the NETCONF Working Group mailing list (mailto:netconf@ietf.org), which is archived at https://mailarchive.ietf.org/arch/browse/netconf/. Subscribe at https://www.ietf.org/mailman/listinfo/netconf/.
Source for this draft and an issue tracker can be found at https://github.com/netconf-wg/restconf-trace-ctx-headers.
Introduction
Network automation and management systems commonly consist of multiple sub-systems and, together with the network devices they manage, they effectively form a distributed system. Distributed tracing is a methodology implemented by tracing tools to track, analyze and debug operations such as configuration transactions, across multiple distributed systems.
The W3C has defined two HTTP headers (traceparent and tracestate) in [W3C-Trace-Context] for context propagation that are useful for distributed systems like the ones defined in section 4 of [RFC8309].
According to the W3C specification, each operation is uniquely identified by a "trace-id" field, and carries multiple metadata fields about the operation. Propagating this Trace Context between systems provides a coherent view of the entire operation as carried out by all involved systems.
The goal of this document is to adopt the W3C [W3C-Trace-Context] specification as optional headers for use with the RESTCONF protocol [RFC8040].
[I-D.draft-ietf-netconf-trace-ctx-extension-01] defines the NETCONF protocol extension for Trace Context propagation. The present document leverages several of the YANG and XML objects defined in that document. Readers should refer to [I-D.draft-ietf-netconf-trace-ctx-extension-01] for additional context and example applications.
Terminology
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT","SHOULD","SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in BCP 14 [RFC2119] [RFC8174] when, and only when, they appear in all capitals, as shown here.
RESTCONF Extensions
A RESTCONF server that implements the Trace Context propagation mechanism defined in this document MUST support the Trace Context traceparent header as defined in [W3C-Trace-Context].
A RESTCONF server SHOULD support the Trace Context tracestate header as defined in [W3C-Trace-Context].
Error Handling
A RESTCONF server SHOULD follow the "Processing Model for Working with Trace Context" as specified in [W3C-Trace-Context]. Based on this processing model, it is NOT RECOMMENDED to reject an RPC because of the Trace Context header values.
If a server decides to reject an RPC because of the Trace Context header values, the server MUST return a RESTCONF rpc-error with the following values:

  error-tag:      operation-failed
  error-type:     protocol
  error-severity: error

Additionally, the error-info tag MUST contain relevant details about the error in the form of an sx:structure otlp-trace-context-error-info defined in ietf-netconf-otlp-context.yang from [I-D.draft-ietf-netconf-trace-ctx-extension-01].
Trace Context Header Versioning
The RESTCONF protocol extension described in this document refers to the [W3C-Trace-Context] Trace Context capability. The W3C traceparent and tracestate headers include the notion of versions. It would be desirable for a RESTCONF client to be able to discover the one or multiple versions of these headers supported by a server.
To achieve this goal while avoiding the definition of new RESTCONF capabilities for each headers' version, [I-D.draft-ietf-netconf-trace-ctx-extension-01] defines a pair of YANG modules that MUST be included in the YANG library per [RFC8525] of the RESTCONF server supporting the RESTCONF Trace Context extension that will refer to the headers' supported versions. Additional YANG modules representing new header versions could be added in future updates of this document.
Security Considerations
The related document [I-D.draft-ietf-netconf-trace-ctx-extension-01] defines two YANG modules that are used when implementing the Trace Context concept, regardless of YANG-based protocol. These modules are completely empty, and therefore have very limited security considerations. Their purpose is only to indicate which Trace Context header versions the server supports using YANG Library [RFC8525].
The traceparent and tracestate headers make it easier to track and correlate the flow of requests and their downstream effect on other systems. This is indeed the whole point with these headers. This knowledge may be used by unauthorized entities to infer a map of a managed network.
All advice mentioned in the [W3C-Trace-Context] under the Privacy Considerations and Security Considerations also apply to this document.
The lowest RESTCONF layer is HTTPS, and the mandatory-to-implement secure transport is TLS [RFC8446].
IANA Considerations
This document has no IANA actions.
Acknowledgments
The authors would like to acknowledge the valuable implementation feedback from Christian Rennerskog and Per Andersson. Many thanks to Raul Rivas Felix, Alexander Stoklasa, Luca Relandini and Erwin Vrolijk for their help with the demos regarding integrations. The help and support from Jean Quilbeuf and Benoît Claise has also been invaluable to this work. Many thanks to Tom Petch and Med Boucadair for their reviews.
References
Normative References
[RFC2119]

Key words for use in RFCs to Indicate Requirement Levels
S. Bradner
March 1997
BCP 14
RFC 2119
DOI 10.17487/RFC2119
[RFC8040]

RESTCONF Protocol
A. Bierman
M. Bjorklund
K. Watsen
January 2017
RFC 8040
DOI 10.17487/RFC8040
[RFC8174]

Ambiguity of Uppercase vs Lowercase in RFC 2119 Key Words
B. Leiba
May 2017
BCP 14
RFC 8174
DOI 10.17487/RFC8174
[RFC8446]

The Transport Layer Security (TLS) Protocol Version 1.3
E. Rescorla
August 2018
RFC 8446
DOI 10.17487/RFC8446
[RFC8525]

YANG Library
A. Bierman
M. Bjorklund
J. Schoenwaelder
K. Watsen
R. Wilton
March 2019
RFC 8525
DOI 10.17487/RFC8525
[I-D.draft-ietf-netconf-trace-ctx-extension-01]

NETCONF Extension to support Trace Context propagation
Roque Gagliano
Cisco Systems
Kristian Larsson
Deutsche Telekom AG
Jan Lindblad
Cisco Systems
8 July 2024
Internet-Draft draft-ietf-netconf-trace-ctx-extension-01
[W3C-Trace-Context]

W3C Recommendation on Trace Context
23 November 2021
Informative References
[RFC8309]

Service Models Explained
Q. Wu
W. Liu
A. Farrel
January 2018
RFC 8309
DOI 10.17487/RFC8309
Example RESTCONF Calls
All examples from Appendix B of [RFC8040] could be recreated in this section by adding the new header described in this document. We selected one example from that document as reference.
Successful creation of New Data Resources (from Appendix B.2.1 of [RFC8040])
To create a new "artist" resource within the "library" resource, a client might send the following request:

  POST /restconf/data/example-jukebox:jukebox/library HTTP/1.1
  Host: example.com
  Content-Type: application/yang-data+json
  traceparent: 00-405062f633be64ee006089dfca95a153-e021f9e263aad8e2-01
  tracestate: vendorname1=opaqueValue1,vendorname2=opaqueValue2

  {
    "example-jukebox:artist" : [
      {
        "name" : "Foo Fighters"
      }
    ]
  }

If the resource is created, the server might respond as follows:

  HTTP/1.1 201 Created
  Date: Thu, 26 Jan 2017 20:56:30 GMT
  Server: example-server
  Location: https://example.com/restconf/data/\
      example-jukebox:jukebox/library/artist=Foo%20Fighters
  Last-Modified: Thu, 26 Jan 2017 20:56:30 GMT
  ETag: "b3830f23a4c"
  traceparent: 00-405062f633be64ee006089dfca95a153-e021f9e263aad8e2-01
  tracestate: vendorname1=opaqueValue1,vendorname2=opaqueValue2

Unsuccessful creation of New Data Resources (from Appendix B.2.1 of [RFC8040])
[W3C-Trace-Context] specifies that a vendor may validate the tracestate header and that invalid headers may be discarded. Section 2.1 on Error handling, states that servers may return an error. Let's assume that an implementation follows that behavior.
Example of a badly formated tracestate header using [RFC8040] example (Appendix B.2.1), in which a server receives the following:

  POST /restconf/data/example-jukebox:jukebox/library HTTP/1.1
  Host: example.com
  Content-Type: application/yang-data+json
  traceparent: 00-405062f633be64ee006089dfca95a153-e021f9e263aad8e2-01
  tracestate: SomeBadFormatHere

  {
    "example-jukebox:artist" : [
      {
        "name" : "Foo Fighters"
      }
    ]
  }

To which the server responds with an error message:

 HTTP/1.1 400 Bad Request
 Date: Thu, 20 Jun 2024 20:56:30 GMT
 Server: example-server
 Content-Type: application/yang-data+json

 { "ietf-restconf:errors" : {
     "error" : [
       {
         "error-type" : "protocol",
         "error-tag" : "operation-failed",
         "error-severity" : "error",
         "error-message" :
           "OTLP traceparent attribute incorrectly formatted",
         "error-info": {
           "ietf-netconf-otlp-context:meta-name" : "tracestate",
           "ietf-netconf-otlp-context:meta-value" :
             "SomeBadFormatHere",
           "ietf-netconf-otlp-context:error-type" :
             "ietf-netconf-otlp-context:bad-format"
         }
       }
     ]
   }
 }

Changes (to be deleted by RFC Editor)
From version 01 to -02
- Removed markdown formatting of tracestate and traceparent, as toolchain could not handle this properly
- Removed references to RFC8341 (NACM) as the passage in the security considerations no longer need it
- Rearranged text in introduction to include referenes in a more natural order
- Removed several references to "we" and replaced with more neutral language
- Clarified that everything described as MUST requirements in this document only apply to RESTCONF implementations that implement this document. Other RESTCONF implementations do not need to care about this document, it's an optional extension
- Clarified that the YANG modules used by this document is defined by the sibling document for NETCONF
- Lots of updated wording based on review feedback
From version 00 to -01
- Added Security considerations
- Added Acknowledgements
- Added several Normative references
- Added links to latest document on github
- Added RESTCONF example for success and error
- Modified Error Handling to reflect better W3C alignment based on implementation feedback
- Firmed up error handling and YANG-library to MUST-requirements
From version 00 to draft-ietf-netconf-restconf-trace-ctx-headers-00
- Adopted by NETCONF WG
- Moved repository to NETCONF WG
- Changed build system to use martinthomson's excellent framework
- Ran make fix-lint to remove white space at EOL etc.
- Added this change note. No other content changes